'''This module can print colored messages to all players'''
''' Howto use:											
	syntax: pprint(<userid/playerlist>,<text>)
	
	To display red, blue or grey, you need at least one player in the matching team.
	For example: If you want to display a red message you need at least one player in the Terrorist team!
	For blue 1 Counter-Terrorist, for grey 1 Spectator. If there is no player in this team the color yellow 
	would be used.
	
	Examples:
		You can use Playerlists:							
			pprint(playerlib.getPlayerList('#ct'),'#redHello world')  # Hello world in red to all ct's
			pprint(playerlib.getPlayerList('#t'),'#blueHello world')   # Hello world in blue to all t's
			pprint(playerlib.getPlayerList('#all'),'#greyHello world') # Hello world in grey to all
		
		Or single IDs:
			pprint(userid,'#redHello world')  		 	# Hello world in red
			pprint(5,'#blueHello world')   	 			# Hello world in blue to playert with userid 5
			pprint(event_var['userid'],'#greyHello world')   # Hello world in grey
			
	
	import pMsg.pMsg
	def player_say(ev):
			text = ev['text']
			userid = ev['userid']
			pMsg.pMsg.pprint(playerlib.getPlayerList('#alive'),"#red" + ev['es_username']+"#default : #redtext") #Print red name and red text to all alive players 
	
	Note: 
		You cant use #red, #blue, #grey or #lightgreen in one command
			pprint(userid,"#redHello #blueWorld") # would display the whole message in red
			
Please report bugs or comments.

eun@1pax.com
'''


import es
import usermsg
import playerlib

info = es.AddonInfo()
info.name = "pMsg"
info.basename = "pMsg"
info.description = "Display colored messages"
info.author = "Eun"
info.version = "0.3"

es.server.cmd('es_xset pMsg 0.3') 
es.makepublic("pMsg")

is_loaded = False

def load():
    global is_loaded
    is_loaded = True
	
def unload():
    global is_loaded
    is_loaded = False	
	
def pprint(usrlist,text):
	mode = 0
	userid = 0
	myPlayerList = playerlib.getPlayerList('#all')
	
	
	if ( text.find("#red") > -1):
		color = 1
	elif ( text.find("#blue") > -1):
		color = 2
	elif ( text.find("#grey") > -1):
		color = 3
	elif ( text.find("#lightgreen") > -1):
		color = 4
	else: color = 0
		
	
	if (color == 1): myPlayerList = playerlib.getPlayerList('#t')
	elif (color == 2): myPlayerList = playerlib.getPlayerList('#ct')
	elif (color == 3): myPlayerList = playerlib.getPlayerList('#spec')
	elif (color == 4): color = 4 # notin todo here
	else: colors = 'default'

	if (type(usrlist) == type(myPlayerList)):
		mode = 1
	elif(type(usrlist) == type(5)):
		mode = 2
	elif(type(usrlist) == type('str')):
		usrlist = int(usrlist)
		mode = 2
	
	text = text.replace('#red', '\3')
	text = text.replace('#blue', '\3')
	text = text.replace('#grey', '\3')
	text = text.replace('#lightgreen', '\3')	

	text = text.replace('#default', '\1')
	text = text.replace('#yellow', '\1')
	text = text.replace('#green', '\4')
	
	
	if (color > 0):
		# getting userid to say from
		for ply in myPlayerList:
			userid = ply.userid
			break
			
		if (userid > 0 ) :
			if (color == 4): index = 0
			else: index = playerlib.getPlayer(userid).attributes['index']
			if (mode == 2): usermsg.saytext2(usrlist, index, "\3" + text)
			else: 
					for user in usrlist:
						usermsg.saytext2(user.userid, index, "\3" + text)
		else:
			if (mode == 2): es.tell(usrlist,"#multi","#default" + text)
			else: 
					for user in usrlist:
						es.tell(user,userid,"#multi","#default" + text)
	else:
		if (mode == 2): es.tell(usrlist,"#multi","#default" + text)
		else: 
			for user in usrlist:
				es.tell(user,userid,"#multi","#default" + text)
